﻿using System;
using System.Collections.Generic;
using System.Collections.Immutable;
using Eingabeverwaltung.Metamodell;

namespace Bewertung
{
    /// <summary>
    /// The Interface for every assessment variant of Proofs with Lemmata.
    /// </summary>
    interface IBewerter
    {
        /// <summary>
        /// runs the assessment
        /// </summary>
        public void Bewerte();
        /// <summary>
        /// Must use Bewerte() before using this.
        /// </summary>
        /// <returns> Returns the result of the assesment: Assessment for each single task.</returns>
        public ImmutableList<IAssessmentResult> GetBewertung();
        /// <summary>
        /// It should be used before outputting the result of the assessment.
        /// </summary>
        /// <returns> Returns the Rounding value for the assessment.</returns>
        public int GetRound();
    }
}
