﻿using Eingabeverwaltung.Parser.ADT_Parser;
using Eingabeverwaltung.Metamodell;
using Antlr4.Runtime.Tree;
using Antlr4.Runtime;

namespace Eingabeverwaltung.Parser
{
	public static class ADT_Antlr
	{
		public static ADT parse(string ADT_input)
        {
			Container container = new Container();

            ICharStream chars = new AntlrInputStream(ADT_input);
			ITokenSource lexer = new ADTLexer(chars);
			ITokenStream tokens = new CommonTokenStream(lexer);
			ADTParser parser = new ADTParser(tokens);

			parser.BuildParseTree = true;

            ADTParser.AdtContext tree = parser.adt();
			Listener_Helper LH = new Listener_Helper();
			IADTListener adt_Listener = new ADT_Listener(container,LH);
			ParseTreeWalker.Default.Walk(adt_Listener, tree);
            LH.close();

            return container.ADT;
        }
	}
}
