﻿using Eingabeverwaltung.Parser.Task_Parser;
using Eingabeverwaltung.Metamodell;
using Antlr4.Runtime.Tree;
using Antlr4.Runtime;

namespace Eingabeverwaltung.Parser
{
	public static class Task_Antlr
	{
		/// <summary>
		/// Requires a Container with filled ADT
		/// </summary>
		/// <param name="Task_input"></param>
		/// <param name="container"></param>
		/// <returns></returns>
		public static void parse(string Task_input, Container container)
		{
			ICharStream chars = new AntlrInputStream(Task_input);
			ITokenSource lexer = new TaskLexer(chars);
			ITokenStream tokens = new CommonTokenStream(lexer);
			TaskParser parser = new TaskParser(tokens);

			parser.BuildParseTree = true;

            Listener_Helper LH = new Listener_Helper(container.ADT.sorts, container.ADT.operations, container.ADT.axioms);
            TaskParser.TaskContext tree = parser.task();
			ITaskListener adt_Listener = new Task_Listener(container,LH);
			ParseTreeWalker.Default.Walk(adt_Listener, tree);
            LH.close();
        }
	}
}
