﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 42
    /// </summary>
    public class CheckIndHypsUnique : ElementChecker
    {
        /// <summary>
        /// checks error 42
        /// </summary>
        public CheckIndHypsUnique() :base() { }
        public override bool check(Element e)
        {
            if (e is Induction ind)
            {
                if (ind.indVar == null) return true;
                bool result = true;
                List<string> ihBuildingVarNames = new List<string>();
                foreach(InductionHypothesis ih in ind.indHyps)
                {
                    CheckHelper.getSubsAndRenamings(ind.eq, ih.eq, out List<Substitution> subs, out List<Substitution> renamings);
                    if (subs == null) continue;
                    string ihBuildingVarName = "";
                    foreach (Substitution renaming in renamings)
                        if (renaming.tree is TreeVariable tv && renaming.variable == ind.indVar)
                            ihBuildingVarName = tv.name;
                    if (ihBuildingVarName != "")
                        if (ihBuildingVarNames.Contains(ihBuildingVarName))
                        { result = false; ih.errors.Add(new Error(42)); }
                        else ihBuildingVarNames.Add(ihBuildingVarName);
                }
                return result;
            }
            else throw new InvalidOperationException();
        }
    }
}
