﻿using Eingabeverwaltung.Metamodell;
using System.Collections.Generic;

namespace Ueberpruefung.CheckInduction
{
    /// <summary>
    /// checks error 40
    /// </summary>
    public class CheckIndPartEquationIsNotFixed : CheckIndPartEquationFixedVars
    {
        public CheckIndPartEquationIsNotFixed(Induction parent) : base(parent) { }

        /// <summary>
        /// checks using the should value and is value of fixed vars. Writes errors to contextErrorList <br></br>
        /// uses check35 from base class.
        /// </summary>
        /// <param name="shouldValueFixedVars"></param>
        /// <param name="isValueFixedVars"></param>
        /// <param name="contextErrorList"></param>
        /// <returns></returns>
        protected override bool check(List<Variable> shouldValueFixedVars, List<Variable> isValueFixedVars, List<Error> contextErrorList)
        {
            isValueFixedVars = new List<Variable>(isValueFixedVars); // copy list
            check35(shouldValueFixedVars, isValueFixedVars, out _);
            bool result = isValueFixedVars.Count == 0;
            if (!result)
            {
                string output = "";
                foreach (Variable var in isValueFixedVars)
                    output += var.name + " ";
                contextErrorList.Add(new Error(40, output));
            }
            return result;
        }
    }
}
